__doc__ = """Stopwatch product module."""

__version__ = '0.1'

from Globals import HTMLFile 
from Globals import MessageDialog
from Globals import Persistent
from DateTime import *

import OFS.SimpleItem
import Acquisition
import AccessControl.Role


manage_addStopwatchForm = HTMLFile('StopwatchAdd', globals()) 

def manage_addStopwatch(self, id, title='', REQUEST=None):
	"""Add a Stopwatch to a folder."""
	self._setObject(id, Stopwatch(id, title))
	if REQUEST is not None:
		return self.manage_main(self, REQUEST)



class Stopwatch(
	OFS.SimpleItem.Item,   
	Persistent,            
	Acquisition.Implicit,  
	AccessControl.Role.RoleManager 
	):
	""" Laufzeitbeobachtung """

	meta_type = 'Stopwatch'

	manage_options = ( 
		{'label': 'Edit',       'action': 'manage_main'},
		{'label': 'View',       'action': ''},
		{'label': 'Security',   'action': 'manage_access'},
		) 

	__ac_permissions__=(
		('View management screens', ('manage_tabs','manage_main')),
		('Change permissions',      ('manage_access',)           ),
		('Change Stopwatchs'     ,     ('manage_edit',)             ),
		('View Stopwatchs',            ('',)                        ),
		)

	def __init__(self, id, title):
		""" Init """
		self.id = id
		self.title = title
		self._start = DateTime()
		self._zeiten = []
		self._stop = DateTime()
		
	index_html = HTMLFile('index', globals())
	manage_main = HTMLFile('StopwatchEdit', globals())
		
	def split(self, s):
		""" setzen """
		self._zeiten.append({'name': str(s), 'zeit': DateTime()})
		
	def start(self):
		""" neu Starten """
		self._zeiten = []
		self._start = DateTime()
		
	def stop(self):
		""" Ausgeben """
		self._stop = DateTime()
		self._zeiten.append({'name': 'Stopped', 'zeit': self._stop})
		return self.__str__()
		
	def get_times(self):
		""" Time-dic """
		return self._zeiten
		
	def __str__(self):
		""" Stringen """
		s = '<b>Times:</b><p><table border=0>'
		for z in self._zeiten:
			s = s + '<tr><td>' + str(z['name']) + ':&nbsp;</td><td align=right>' + str(round((z['zeit'] - self._sta